#-*- coding:utf-8 -*-

import clr
import sys

clr.AddReferenceByPartialName("PresentationCore")
clr.AddReferenceByPartialName("PresentationFramework")
clr.AddReferenceByPartialName("WindowsBase")
clr.AddReference("System.Management")

from System import *
from System.IO import *
from System.Windows import *
from System.Windows.Controls import *
from System.Windows.Controls.Primitives import *
from System.Windows.Input import *
from System.Collections.ObjectModel import *
from System.Windows.Markup import XamlReader
from System.Windows.Media.Imaging import *
from System.Windows.Media.Effects import *
import System.Management
import inifile8
from xamls import *
from datas import *
from strs import *
import aboutdlg

class SeeMe(Window):
    """
        SeeMe MainWindow class
    """
    def __init__(self, sset):
        """
            Window.__init__(self) is No
            Constructor has been
        """
        # Memory FilePath
        self.path = Path.GetDirectoryName(Path.GetFullPath(__file__))
        self.sset = sset
        self.iniver = 0
        # Menu
        menu = XamlReader.Parse(menu_str)
        menu.FindName("save").Click += self.on_save
        menu.FindName("quit").Click += self.on_quit
        menu.FindName("about").Click += self.on_about
        DockPanel.SetDock(menu, Dock.Top)
        # ToolBar
        toolbar = XamlReader.Parse(toolbar_str)
        toolbar.FindName("btn2").Click += self.on_save
        toolbar.FindName("img1").Source = BitmapImage(Uri(self.path + "\\img\\i_new.png"))
        toolbar.FindName("img2").Source = BitmapImage(Uri(self.path + "\\img\\i_save.png"))
        toolbar.FindName("img3").Source = BitmapImage(Uri(self.path + "\\img\\i_up.png"))
        toolbar.FindName("img4").Source = BitmapImage(Uri(self.path + "\\img\\i_down.png"))
        toolbar.FindName("img5").Source = BitmapImage(Uri(self.path + "\\img\\i_del.png"))
        DockPanel.SetDock(toolbar, Dock.Top)
        # ObservableCollection
        self.custome_liststore = ObservableCollection[Engine]()
        #self.default_liststore = ObservableCollection[Engine]()
        # ListView
        self.custome_listview = XamlReader.Parse(listview_str)
        DockPanel.SetDock(self.custome_listview, Dock.Top)
        self.custome_listview.ItemsSource = self.custome_liststore
        self.default_listview = XamlReader.Parse(listview_str)
        DockPanel.SetDock(self.default_listview, Dock.Top)
        #self.default_listview.ItemsSource = self.default_liststore
        # Notebook
        self.page = []
        note = TabControl()
        for i in range(3):
            page = TabItem()
            page.Header = tab_label[i]
            note.AddChild(page)
            self.page.append(page)
        self.page[0].Content = self.custome_listview
        self.page[1].Content = self.default_listview
        # StatusBar
        statusbar = StatusBar()
        DockPanel.SetDock(statusbar, Dock.Bottom)
        self.statusbar_item = StatusBarItem()
        self.statusbar_item.Content = "Search.ini Version"
        statusbar.Items.Add(self.statusbar_item)
        # DockPanel
        docpanel = DockPanel()
        docpanel.Children.Add(menu)
        docpanel.Children.Add(toolbar)
        docpanel.Children.Add(statusbar)
        docpanel.Children.Add(note)
        # self
        self.Content = docpanel
        self.Width = 500
        self.Height = 300
        self.Title = "SeeMe for Windows v5"
        # event
        self.KeyDown += self.on_keydown
        # read
        self.read_default_searchini()
        self.read_custome_searchini()
        self.read_operaprefs_ini()
        #self.FontFamily = Input.FontFamily("メイリオ")


########################################################################
#
#                          Functions
#
########################################################################


    def messagebox(self, text):
        return MessageBox.Show(text, MESSAGEDLG_TITLE)

    def read_default_searchini(self):
        #self.default_liststore.Clear()
        ini_path = self.sset.default_path
        lng_path = self.sset.lang_path
        if (File.Exists(ini_path)):
            ini = inifile8.Inifile(ini_path)
            lng = inifile8.InifileReader(lng_path)
            try:
                self.iniver = ini.read_int("Version", "File Version", 0)
                i = 0
                while 1:
                    i += 1
                    s = "Search Engine %i" % i
                    if not ini.section_exists(s):
                        break
                    t = ini.read_str(s, "Key", "")
                    if t == "":
                        continue
                    en = Engine();
                    en.nameid = ini.read_int(s, "Nameid", 0);
                    if en.nameid != 0:
                        # lng から表示名を取ってくる
                        # Google の計算方法が不明だけどコレで問題無いからイイや！
                        if en.nameid == 17171:
                            en.name = lng.read_str("Translation", "1632215285", "")
                        elif en.nameid == 17183:
                            en.name = lng.read_str("Translation", "-1971470391", "")
                        elif en.nameid == 71103:
                            en.name = lng.read_str("Translation", "-1453429782", "")
                        else:
                            en.name = lng.read_str("Translation", str(en.nameid), "")
                        if en.name == "":
                            n = -1752227277 - en.nameid;
                            en.name = lng.read_str("Translation", str(n), "")
                    else:
                        en.name = ini.read_str(s, "Name", "")
                        #en.name = unicode(ini.read_str(s, "Name", ""), "utf8")
                        #print en.name
                    en.key    = t
                    en.url    = ini.read_str(s, "URL", "")
                    en.query  = ini.read_str(s, "Query", "")
                    en.post   = ini.read_bool(s, "Is post", False)
                    en.endsep = ini.read_bool(s, "Has endseparator", False)
                    en.encode = ini.read_str(s, "Encoding", "utf-8")
                    en.type   = ini.read_int(s, "Search Type", 0)
                    en.pos    = ini.read_int(s, "Position", -1)
                    en.verb   = ini.read_int(s, "Verbtext", 0)
                    en.delete = True #！
                    en.unique = ini.read_str(s, "UNIQUEID", "")
                    en.icon   = ini.read_str(s, "ICON", "")
                    en.usetld = ini.read_int(s, "UseTLD", 0)
                    #self.default_liststore.Add(en)
                    self.default_listview.Items.Add(en)
            except Exception, s:
                self.messagebox("%s" % s)
                sys.exit()

    def read_custome_searchini(self):
        self.custome_liststore.Clear()
        ini_path = self.sset.custome_path
        if (File.Exists(ini_path)):
            ini = inifile8.Inifile(ini_path)
            try:
                if self.iniver == 0:
                    self.iniver = ini.read_int("Version", "File Version", 0)
                self.statusbar_item.Content = "Search.ini Version " + str(self.iniver)
                s = ""
                i = 0
                while 1:
                    i += 1
                    s = "Search Engine %i" % i
                    if not ini.section_exists(s):
                        break
                    en = Engine()
                    en.name   = ini.read_str(s, "Name", "")
                    en.key    = ini.read_str(s, "Key", "")
                    en.url    = ini.read_str(s, "URL", "")
                    en.delete = not ini.read_bool(s, "Deleted", False)
                    en.query  = ini.read_str(s, "Query", "")
                    en.post   = ini.read_bool(s, "Is post", False)
                    en.endsep = ini.read_bool(s, "Has endseparator", False)
                    en.encode = ini.read_str(s, "Encoding", "utf-8")
                    en.type   = ini.read_int(s, "Search Type", 0)
                    en.pos    = ini.read_int(s, "Position", -1)
                    en.nameid = ini.read_int(s, "Nameid", 0)
                    en.verb   = ini.read_int(s, "Verbtext", 0)
                    en.icon   = ini.read_str(s, "ICON", "")
                    en.unique = ini.read_str(s, "UNIQUEID", "")
                    en.usetld = ini.read_int(s, "UseTLD", 0)
                    self.custome_liststore.Add(en)
            except Exception, s:
                self.messagebox("%s" % s)
                sys.exit()

    def read_operaprefs_ini(self):
        pass

    def create_uuid(self):
        pass


########################################################################
#
#                          Menu and Toolbar
#
########################################################################


    def on_save(self, sender, e):
        """
            none
        """
        pass

    def on_quit(self, sender, e):
        """
            exit
        """
        self.Close()

    def on_about(self, sender, e):
        dlg = aboutdlg.AboutDlg(self)
        dlg.Show()

    def on_keydown(self, sender, e):
        """
            e as System.Windows.Input.KeyEventArgs
        """
        if Keyboard.Modifiers == ModifierKeys.Control:
            if e.Key == Key.O:
                self.on_save(self, e)
            if e.Key == Key.Q:
                self.on_quit(self, e)


########################################################################
#
#                               Welcome
#
########################################################################


class WelcomeDlg(Window):
    """
        SeeMe Welcome class
    """
    def __init__(self, sset, text):
        names = ["Default search.ini", "Custome search.ini", "lng File"]
        self.entrys = []
        sp = StackPanel()
        # description
        description = TextBlock()
        description.Text = text
        sp.Children.Add(description)
        # Edit
        for i in range(3):
            dp = DockPanel()
            tb = TextBlock()
            tb.Text = names[i]
            tb.MinWidth = 130
            tx = TextBox()
            tx.AllowDrop = True
            tx.Drop += self.on_drop
            tx.PreviewDragOver += self.on_drag_over
            self.entrys.append(tx)
            dp.Children.Add(tb)
            dp.Children.Add(tx)
            sp.Children.Add(dp)
        buttons = DockPanel()
        buttons.LastChildFill = False
        ok = Button()
        ok.Content = "_Ok"
        ok.IsDefault = True
        ok.Width = 100
        ok.Height = 23
        ok.Click += self.on_ok
        DockPanel.SetDock(ok, Dock.Right)
        buttons.Children.Add(ok)
        cancel = Button()
        cancel.Content = "Cancel"
        cancel.IsCancel = True
        cancel.Width = 100
        cancel.Height = 23
        cancel.Click += self.on_cancel
        DockPanel.SetDock(cancel, Dock.Right)
        buttons.Children.Add(cancel)
        sp.Children.Add(buttons)
        self.Content = sp
        # path x86 or x64
        prfiles = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles)
        appdata = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData)
        mc = System.Management.ManagementClass("Win32_Processor")
        moc = mc.GetInstances()
        # mo is ManagementObject
        for mo in moc:
            bit = mo["AddressWidth"]
            if bit == 64:
                prfiles += " (x86)"
        # Value Set
        if sset.default_path == "":
            self.entrys[0].Text = prfiles + "\\Opera\\locale\\ja\\search.ini"
        else:
            self.entrys[0].Text = sset.default_path
        if sset.custome_path == "":
            self.entrys[1].Text = appdata + "\\Opera\\Opera\\search.ini"
        else:
            self.entrys[1].Text = sset.custome_path
        if sset.lang_path == "":
            self.entrys[2].Text = prfiles + "\\Opera\\locale\\ja\\ja.lng"
        else:
            self.entrys[2].Text = sset.lang_path
        # self
        self.Title = "Seeme へようこそ"
        self.SizeToContent = SizeToContent.WidthAndHeight
        self.WindowStartupLocation = WindowStartupLocation.CenterScreen
        self.WindowStyle = WindowStyle.ThreeDBorderWindow

    def on_drag_over(self, sender, e):
        e.Handled = e.Data.GetData(DataFormats.FileDrop) != None

    def on_drop(self, sender, e):
        files = e.Data.GetData(DataFormats.FileDrop)
        sender.Text = str(files[0])

    def on_ok(self, sender, e):
        self.DialogResult = True
        self.Close()

    def on_cancel(self, sender, e):
        self.DialogResult = False
        self.Close()

########################################################################
#
#                               main
#
########################################################################

def main():
    inipath = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\sasakima\\seeme\\setting4.ini";
    sset = SeeMeSetting()
    ini = inifile8.Inifile(inipath)
    try:
        sset.version = ini.read_int("Version", "File Version", 0)
        sset.width = ini.read_int("Window", "Width", 500)
        sset.height = ini.read_int("Window", "Height", 500)
        sset.top = ini.read_int("Window", "Top", 100)
        sset.left = ini.read_int("Window", "Left", 100)
        sset.default_path = ini.read_str("Path", "Default1", "")
        sset.custome_path = ini.read_str("Path", "Custome1", "")
        sset.prefs_path = ini.read_str("Path", "Prefs1", "")
        sset.lang_path = ini.read_str("Path", "Lang1", "")
        sset.default_path2 = ini.read_str("Path", "Default2", "")
        sset.custome_path2 = ini.read_str("Path", "Custome2", "")
        sset.prefs_path2 = ini.read_str("Path", "Prefs2", "")
        sset.lang_path2 = ini.read_str("Path", "Lang2", "")
        sset.texteditor = ini.read_str("Setting", "Editor", "")
        sset.verbtext = ini.read_int("Setting", "Verbtext", 0)
    except Exception, s:
        MessageBox.Show("%s" % s, MESSAGEDLG_TITLE)
        sys.exit()
    if sset.version < 4:
        # New
        if sset.version == 0:
            description = WELCOME_DESCRIPTION
        else:
            description = CHANGE_DESCRIPTION
        # file version 1 to 2
        sset.default_path = ""
        sset.lang_path    = ""
        # end
        dlg = WelcomeDlg(sset, description)
        try:
            # dlg.Show() で表示すると即終了
            if dlg.ShowDialog():#.Value: は不要
                sset.default_path = dlg.entrys[0].Text
                sset.custome_path = dlg.entrys[1].Text
                sset.lang_path =    dlg.entrys[2].Text
            else:
                MessageBox.Show("bye !", MESSAGEDLG_TITLE)
                return # sys.exit() ではインスタンス終了しない
        except Exception, s:
            MessageBox.Show("%s" % s, MESSAGEDLG_TITLE)
        a = Application()
        a.Run(SeeMe(sset))

if __name__ == "__main__":
    main()